﻿<AML>
 <Item type="Method" id="E5790EC329624A6E98FF1F54803DEF80" action="add">
  <comments>2018-01-13--MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			sop_price_change
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	When Price change,
	-Calculate Sub Amount,GST Amount and Total Amount and set.
	
Hooks:

    Type:	ItemType	:	sop_sale_order_details
	Event:	stk_code ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_out_details
	Event:	stk_code ( OnEditFinish )
	
	Type:	ItemType	:	sop_sale_invoice_details
	Event:	stk_code ( OnEditFinish )
	
	Type:	ItemType	:	sop_sale_invoice_details
	Event:	stk_code_type ( OnEditFinish )
	
	Type:	ItemType	:	sop_commercial_invoice_details
	Event:	stk_code ( OnEditFinish )
	
	Type:	ItemType	:	sop_invoice_ser_part_detail
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_sale_invoice
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_ci_ser_part_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	pop_invoice_service_part
	Event:	stk_price ( OnEditFinish )
	
    Type:	ItemType	:	sop_sale_order_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_sale_order_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_commercial_invoice_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	pop_invoice_service_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_out_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_sale_invoice_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_service_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_service_part_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_ci_service_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_so_service
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_invoice_service_details
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_so_service_part
	Event:	stk_price ( OnEditFinish )
	
	Type:	ItemType	:	sop_invoice_service_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_ci_ser_part_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_so_service_part
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_ci_service_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_service_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_commercial_invoice_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_out_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_service_part_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_po_service_part_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	pop_invoice_service_part
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_sale_invoice_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_so_service
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	pop_invoice_service_details
	Event:	stk_qty ( OnEditFinish )
	
	Type:	ItemType	:	sop_invoice_ser_part_detail
	Event:	stk_qty ( OnEditFinish )

Revisions:
	Rev Date		Modified By			Description
	2018-03-07		Chan			Discount does not greater than Total Amount.
	2019-05-07		Chan			Remove Checking that Discount does not greater than Total Amount.
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();

var relitm = parent.thisItem.getItemsByXPath("//Item[@id='" + relationshipID + "']");

/** Purchase Order and Commercial Invoice have discount
 * Sub Total = AllLinesTotal - Discount
 * pop_hide_sub_total property is used as AllLinesTotal
 * */
var pop_sub_amount = parent.thisItem.getProperty("pop_sub_amount", "0");
var typeOfParentItem = parent.thisItem.getType().toString().toLowerCase();
switch (typeOfParentItem) {
    case 'sop_po_out':
    case 'sop_sale_invoice':
        {
            var pop_sub_amount = parent.thisItem.getProperty("pop_hide_sub_total", "0");
        }
        break;
}

/**
 * Column number are very sensitive.  Always count on grid view.
 * If you change view hidden , you need to recheck column number.
 * girdApplet.GetColumnIndex(property_name_D) works correctly for null relationship.
 * var totalColumnIndex = gridApplet.GetColumnIndex("stk_total_amount_D");
 * */
var priceColumnIndex = 3;
var totalColumnIndex = 4;
var typeOfRelatedItem = relitm.getType().toString().toLowerCase();
switch (typeOfRelatedItem) {

    case 'sop_ci_ser_part_details':
        {
            totalColumnIndex = 4;
        }
        break;
    case 'sop_sale_order_details':
    case 'sop_section_details':
    case 'sop_po_out_details':
    case 'sop_sale_invoice_details':
    case 'sop_commercial_invoice_details':
    // case 'sop_invoice_ser_part_detail':
    case 'pop_invoice_service_part':
    case 'pop_invoice_service_details':
    // case 'sop_po_service_details':
    // case 'sop_po_service_part_details':
    // case 'sop_ci_service_details':
    // case 'sop_so_service':  
    // case 'sop_invoice_service_details': 
    // case 'sop_so_service_part':  
        {
            priceColumnIndex = gridApplet.GetColumnIndex("stk_price_D");
            totalColumnIndex = gridApplet.GetColumnIndex("stk_total_amount_D");
        }
        break;
}

var f_sub_amount = parseFloat(pop_sub_amount);

var pop_gst_percent = parent.thisItem.getProperty("pop_gst_percent", "0");
var f_gst_percent = parseFloat(pop_gst_percent) / 100;

var pop_lumpsum_discount = parent.thisItem.getProperty("pop_lumpsum_discount", "0");
var f_discount = parseFloat(pop_lumpsum_discount);

var stk_qty = relitm.getProperty("stk_qty", "");
var f_qty = parseFloat(stk_qty, 10);

var stk_price = relitm.getProperty("stk_price", "");
if (stk_price === "") {
    stk_price = "0";
    gridApplet.SetCellValue(relationshipID, priceColumnIndex, stk_price);
    relitm.setProperty("stk_price", stk_price);
}
var f_price = parseFloat(stk_price);
var old_line_total = relitm.getProperty("stk_total_amount", "");
var f_old_line_total = parseFloat(old_line_total);

if (isNaN(f_old_line_total)) {
    f_old_line_total = 0;
    f_sub_amount = 0;
}

var f_new_line_total = f_qty * f_price;

gridApplet.SetCellValue(relationshipID, totalColumnIndex, f_new_line_total.toString());
relitm.setProperty("stk_total_amount", f_new_line_total.toString());

f_sub_amount -= f_old_line_total;
f_sub_amount += f_new_line_total;

myHandleItemChange("pop_hide_sub_total", f_sub_amount.toFixed(2));

f_sub_amount = f_sub_amount - f_discount;
myHandleItemChange("pop_sub_amount", f_sub_amount.toFixed(2));

var gst_amount = (f_sub_amount * f_gst_percent);
myHandleItemChange("pop_gst_amount", gst_amount.toFixed(2));

var total_amount = (f_sub_amount + gst_amount);
myHandleItemChange("pop_total_amount", total_amount.toFixed(2));

function myHandleItemChange(property, value) {
    if (top.instance.document) {
        
        top.instance.handleItemChange(property, value);
    } else {
        
        top.frames[1].handleItemChange(property, value);
    }
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>sop_price_change</name>
 </Item>
</AML>